/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

//>>built
define("dojo/data/ItemFileReadStore",["../_base/kernel","../_base/lang","../_base/declare","../_base/array","../_base/xhr","../Evented","../_base/window","./util/filter","./util/simpleFetch","../date/stamp"],function(p,h,m,u,q,v,k,t,w,x){m=m("dojo.data.ItemFileReadStore",[v],{constructor:function(a){this._arrayOfAllItems=[];this._arrayOfTopLevelItems=[];this._loadFinished=!1;this.url=this._ccUrl=this._jsonFileUrl=a.url;this._jsonData=a.data;this.data=null;this._datatypeMap=a.typeMap||{};this._datatypeMap.Date||
(this._datatypeMap.Date={type:Date,deserialize:function(a){return x.fromISOString(a)}});this._features={"dojo.data.api.Read":!0,"dojo.data.api.Identity":!0};this._itemsByIdentity=null;this._storeRefPropName="_S";this._itemNumPropName="_0";this._rootItemPropName="_RI";this._reverseRefMap="_RRM";this._loadInProgress=!1;this._queuedFetches=[];if(a.urlPreventCache!==void 0)this.urlPreventCache=a.urlPreventCache?!0:!1;if(a.hierarchical!==void 0)this.hierarchical=a.hierarchical?!0:!1;if(a.clearOnClose)this.clearOnClose=
!0;if("failOk"in a)this.failOk=a.failOk?!0:!1},url:"",_ccUrl:"",data:null,typeMap:null,clearOnClose:!1,urlPreventCache:!1,failOk:!1,hierarchical:!0,_assertIsItem:function(a){if(!this.isItem(a))throw Error("dojo.data.ItemFileReadStore: Invalid item argument.");},_assertIsAttribute:function(a){if(typeof a!=="string")throw Error("dojo.data.ItemFileReadStore: Invalid attribute argument.");},getValue:function(a,b,c){a=this.getValues(a,b);return a.length>0?a[0]:c},getValues:function(a,b){this._assertIsItem(a);
this._assertIsAttribute(b);return(a[b]||[]).slice(0)},getAttributes:function(a){this._assertIsItem(a);var b=[],c;for(c in a)c!==this._storeRefPropName&&c!==this._itemNumPropName&&c!==this._rootItemPropName&&c!==this._reverseRefMap&&b.push(c);return b},hasAttribute:function(a,b){this._assertIsItem(a);this._assertIsAttribute(b);return b in a},containsValue:function(a,b,c){var d=void 0;typeof c==="string"&&(d=t.patternToRegExp(c,!1));return this._containsValue(a,b,c,d)},_containsValue:function(a,b,c,
d){return u.some(this.getValues(a,b),function(a){if(a!==null&&!h.isObject(a)&&d){if(a.toString().match(d))return!0}else if(c===a)return!0})},isItem:function(a){if(a&&a[this._storeRefPropName]===this&&this._arrayOfAllItems[a[this._itemNumPropName]]===a)return!0;return!1},isItemLoaded:function(a){return this.isItem(a)},loadItem:function(a){this._assertIsItem(a.item)},getFeatures:function(){return this._features},getLabel:function(a){if(this._labelAttr&&this.isItem(a))return this.getValue(a,this._labelAttr)},
getLabelAttributes:function(){if(this._labelAttr)return[this._labelAttr];return null},_fetchItems:function(a,b,c){var d=this,h=function(a,c){var f=[],e,g;if(a.query){var h;e=a.queryOptions?a.queryOptions.ignoreCase:!1;var r={};for(g in a.query)h=a.query[g],typeof h==="string"?r[g]=t.patternToRegExp(h,e):h instanceof RegExp&&(r[g]=h);for(e=0;e<c.length;++e){var n=!0,s=c[e];if(s===null)n=!1;else for(g in a.query)h=a.query[g],d._containsValue(s,g,h,r[g])||(n=!1);n&&f.push(s)}}else for(e=0;e<c.length;++e)g=
c[e],g!==null&&f.push(g);b(f,a)};if(this._loadFinished)h(a,this._getItemsArray(a.queryOptions));else{if(this._jsonFileUrl!==this._ccUrl)p.deprecated("dojo.data.ItemFileReadStore: ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this.url=this._ccUrl=this._jsonFileUrl;else if(this.url!==this._ccUrl)this._ccUrl=this._jsonFileUrl=this.url;if(this.data!=null)this._jsonData=this.data,this.data=null;if(this._jsonFileUrl)if(this._loadInProgress)this._queuedFetches.push({args:a,
filter:h});else{this._loadInProgress=!0;var f=q.get({url:d._jsonFileUrl,handleAs:"json-comment-optional",preventCache:this.urlPreventCache,failOk:this.failOk});f.addCallback(function(b){try{d._getItemsFromLoadedData(b),d._loadFinished=!0,d._loadInProgress=!1,h(a,d._getItemsArray(a.queryOptions)),d._handleQueuedFetches()}catch(e){d._loadFinished=!0,d._loadInProgress=!1,c(e,a)}});f.addErrback(function(b){d._loadInProgress=!1;c(b,a)});var e=null;if(a.abort)e=a.abort;a.abort=function(){f&&f.fired===-1&&
f.cancel();e&&e.call(a)}}else if(this._jsonData)try{this._loadFinished=!0,this._getItemsFromLoadedData(this._jsonData),this._jsonData=null,h(a,this._getItemsArray(a.queryOptions))}catch(g){c(g,a)}else c(Error("dojo.data.ItemFileReadStore: No JSON source data was provided as either URL or a nested Javascript object."),a)}},_handleQueuedFetches:function(){if(this._queuedFetches.length>0){for(var a=0;a<this._queuedFetches.length;a++){var b=this._queuedFetches[a],c=b.args;(b=b.filter)?b(c,this._getItemsArray(c.queryOptions)):
this.fetchItemByIdentity(c)}this._queuedFetches=[]}},_getItemsArray:function(a){if(a&&a.deep)return this._arrayOfAllItems;return this._arrayOfTopLevelItems},close:function(){if(this.clearOnClose&&this._loadFinished&&!this._loadInProgress)this._arrayOfAllItems=[],this._arrayOfTopLevelItems=[],this._loadFinished=!1,this._itemsByIdentity=null,this._loadInProgress=!1,this._queuedFetches=[]},_getItemsFromLoadedData:function(a){function b(a){return a!==null&&typeof a==="object"&&(!h.isArray(a)||d)&&!h.isFunction(a)&&
(a.constructor==Object||h.isArray(a))&&typeof a._reference==="undefined"&&typeof a._type==="undefined"&&typeof a._value==="undefined"&&n.hierarchical}function c(a){n._arrayOfAllItems.push(a);for(var e in a){var d=a[e];if(d)if(h.isArray(d))for(var f=0;f<d.length;++f){var g=d[f];b(g)&&c(g)}else b(d)&&c(d)}}var d=!1,n=this;this._labelAttr=a.label;var f,e;this._arrayOfAllItems=[];this._arrayOfTopLevelItems=a.items;for(f=0;f<this._arrayOfTopLevelItems.length;++f)e=this._arrayOfTopLevelItems[f],h.isArray(e)&&
(d=!0),c(e),e[this._rootItemPropName]=!0;var g={},j;for(f=0;f<this._arrayOfAllItems.length;++f)for(j in e=this._arrayOfAllItems[f],e){if(j!==this._rootItemPropName){var i=e[j];i!==null?h.isArray(i)||(e[j]=[i]):e[j]=[null]}g[j]=j}for(;g[this._storeRefPropName];)this._storeRefPropName+="_";for(;g[this._itemNumPropName];)this._itemNumPropName+="_";for(;g[this._reverseRefMap];)this._reverseRefMap+="_";if(g=a.identifier){this._itemsByIdentity={};this._features["dojo.data.api.Identity"]=g;for(f=0;f<this._arrayOfAllItems.length;++f)if(e=
this._arrayOfAllItems[f],a=e[g],a=a[0],Object.hasOwnProperty.call(this._itemsByIdentity,a))if(this._jsonFileUrl)throw Error("dojo.data.ItemFileReadStore:  The json data as specified by: ["+this._jsonFileUrl+"] is malformed.  Items within the list have identifier: ["+g+"].  Value collided: ["+a+"]");else{if(this._jsonData)throw Error("dojo.data.ItemFileReadStore:  The json data provided by the creation arguments is malformed.  Items within the list have identifier: ["+g+"].  Value collided: ["+a+"]");
}else this._itemsByIdentity[a]=e}else this._features["dojo.data.api.Identity"]=Number;for(f=0;f<this._arrayOfAllItems.length;++f)e=this._arrayOfAllItems[f],e[this._storeRefPropName]=this,e[this._itemNumPropName]=f;for(f=0;f<this._arrayOfAllItems.length;++f)for(j in e=this._arrayOfAllItems[f],e){a=e[j];for(g=0;g<a.length;++g)if(i=a[g],i!==null&&typeof i=="object"){if("_type"in i&&"_value"in i){var o=i._type,l=this._datatypeMap[o];if(l)if(h.isFunction(l))a[g]=new l(i._value);else if(h.isFunction(l.deserialize))a[g]=
l.deserialize(i._value);else throw Error("dojo.data.ItemFileReadStore: Value provided in typeMap was neither a constructor, nor a an object with a deserialize function");else throw Error("dojo.data.ItemFileReadStore: in the typeMap constructor arg, no object class was specified for the datatype '"+o+"'");}if(i._reference){i=i._reference;if(h.isObject(i))for(o=0;o<this._arrayOfAllItems.length;++o){var l=this._arrayOfAllItems[o],m=!0,k;for(k in i)l[k]!=i[k]&&(m=!1);m&&(a[g]=l)}else a[g]=this._getItemByIdentity(i);
this.referenceIntegrity&&(i=a[g],this.isItem(i)&&this._addReferenceToMap(i,e,j))}else this.isItem(i)&&this.referenceIntegrity&&this._addReferenceToMap(i,e,j)}}},_addReferenceToMap:function(){},getIdentity:function(a){var b=this._features["dojo.data.api.Identity"];if(b===Number)return a[this._itemNumPropName];else if(a=a[b])return a[0];return null},fetchItemByIdentity:function(a){var b,c;if(this._loadFinished)b=this._getItemByIdentity(a.identity),a.onItem&&(c=a.scope?a.scope:k.global,a.onItem.call(c,
b));else{var d=this;if(this._jsonFileUrl!==this._ccUrl)p.deprecated("dojo.data.ItemFileReadStore: ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this.url=this._ccUrl=this._jsonFileUrl;else if(this.url!==this._ccUrl)this._ccUrl=this._jsonFileUrl=this.url;if(this.data!=null&&this._jsonData==null)this._jsonData=this.data,this.data=null;if(this._jsonFileUrl)this._loadInProgress?this._queuedFetches.push({args:a}):(this._loadInProgress=
!0,c=q.get({url:d._jsonFileUrl,handleAs:"json-comment-optional",preventCache:this.urlPreventCache,failOk:this.failOk}),c.addCallback(function(c){var f=a.scope?a.scope:k.global;try{d._getItemsFromLoadedData(c),d._loadFinished=!0,d._loadInProgress=!1,b=d._getItemByIdentity(a.identity),a.onItem&&a.onItem.call(f,b),d._handleQueuedFetches()}catch(e){d._loadInProgress=!1,a.onError&&a.onError.call(f,e)}}),c.addErrback(function(b){d._loadInProgress=!1;a.onError&&a.onError.call(a.scope?a.scope:k.global,b)}));
else if(this._jsonData)d._getItemsFromLoadedData(d._jsonData),d._jsonData=null,d._loadFinished=!0,b=d._getItemByIdentity(a.identity),a.onItem&&(c=a.scope?a.scope:k.global,a.onItem.call(c,b))}},_getItemByIdentity:function(a){var b=null;this._itemsByIdentity?Object.hasOwnProperty.call(this._itemsByIdentity,a)&&(b=this._itemsByIdentity[a]):Object.hasOwnProperty.call(this._arrayOfAllItems,a)&&(b=this._arrayOfAllItems[a]);b===void 0&&(b=null);return b},getIdentityAttributes:function(){var a=this._features["dojo.data.api.Identity"];
return a===Number?null:[a]},_forceLoad:function(){var a=this;if(this._jsonFileUrl!==this._ccUrl)p.deprecated("dojo.data.ItemFileReadStore: ","To change the url, set the url property of the store, not _jsonFileUrl.  _jsonFileUrl support will be removed in 2.0"),this.url=this._ccUrl=this._jsonFileUrl;else if(this.url!==this._ccUrl)this._ccUrl=this._jsonFileUrl=this.url;if(this.data!=null)this._jsonData=this.data,this.data=null;if(this._jsonFileUrl){var b=q.get({url:this._jsonFileUrl,handleAs:"json-comment-optional",
preventCache:this.urlPreventCache,failOk:this.failOk,sync:!0});b.addCallback(function(b){try{if(a._loadInProgress!==!0&&!a._loadFinished)a._getItemsFromLoadedData(b),a._loadFinished=!0;else if(a._loadInProgress)throw Error("dojo.data.ItemFileReadStore:  Unable to perform a synchronous load, an async load is in progress.");}catch(d){throw d;}});b.addErrback(function(a){throw a;})}else if(this._jsonData)a._getItemsFromLoadedData(a._jsonData),a._jsonData=null,a._loadFinished=!0}});h.extend(m,w);return m});